import voxellib.Mesh;

  int dimX=20;
  int dimY=10;
  int dimZ=30;

  boolean solid[][][]; 
  float bSize=15;
  Mesh mesh;

  public void setup(){
    
    size(700, 700, P3D);
    pixelDensity(displayDensity());
    
    mesh=new Mesh(this); //create the mesh

    //fill it with random values
    solid=new boolean[dimX][dimY][dimZ];
    for (int i = 0; i < dimX; ++i) {
      for (int j = 0; j < dimY; ++j) {
        for (int k = 0; k < dimZ; ++k) {
          solid[i][j][k]=random(0, 100)<30;
        }
      }
    }
  
    //they can also be called from draw()
    //but since nothing changes...
    mesh.makeFromVoxels(solid, bSize);
    mesh.saveAsStl("boxesFile.stl");

  }

  public void draw(){

    background(255);
    ambientLight(50,50,50);
    directionalLight(255,255,255,50,60,-30);
    translate(350,350,-100);
    rotateX(-PI/6);
    rotateY(mouseX*0.05);
    //rotateZ(PI/2);
    
    translate( -dimX*bSize/2, -dimY*bSize/2, -dimZ*bSize/2);
    mesh.draw();
  }
  