import voxellib.Mesh;

int dimX=40;
int dimY=40;
int dimZ=20;

 float solid[][][]; 
 float bSize=15;
  Mesh mesh;

  public void setup(){
    
    size(700, 700, P3D);
    pixelDensity(displayDensity());
    noStroke();
    mesh=new Mesh(this);
  
   //fill the voxels using perlin noise
    solid=new float[dimX][dimY][dimZ];
    for (int i = 0; i < dimX; ++i) {
      for (int j = 0; j < dimY; ++j) {
        for (int k = 0; k < dimZ; ++k) {
          solid[i][j][k]=noise(i*0.05, j*0.05, k*0.05); //perlin noise
        }
      }
    }
    
    //they can also be called from draw()
    //but since nothing changes...
    mesh.makeFromVoxels(solid, bSize,0.5f);
    mesh.saveAsStl("MarchingCubes.stl");
  }

  public void draw(){

    background(255);
    ambientLight(50,50,50);
    directionalLight(255,255,255,20,60,-30);
    translate(350,350,-400);
    rotateX(-PI/6);
    rotateY(mouseX*0.05);
    rotateZ(PI/2);
   
    translate( -dimX*bSize/2, -dimY*bSize/2, -dimZ*bSize/2);
    mesh.draw();

  }
  